摘要: 前置题目:P4151| 题解。 也是在 ABC 尝到 WC 的菜了。 先套路的使用 P4151 的结论,可以发现环的贡献依然可以任意加到答案中,链也是可以任意选择的。 猜你想看 这里说明一下上面的是什么意思。考虑先建出 dfs 树,然后的话从 \(u\) 到 \(v\) 的路径可以转化为树上从 \( 阅读全文
posted @ 2026-05-20 21:52 WinterXorSnow 阅读(14) 评论(0) 推荐(0)
摘要: 题目链接。 依旧看到异或尝试使用01trie或者线性基。 发现这道题目 01trie 大概是不好写的,因此考虑线性基。 不难将问题转化成链+环的形式,即在链上再加上若干环的贡献。 可以证明的是,环的贡献是可以任意加的,假设我们现在在某一位置上,我们就可以去到环上再回来,只会产生环的贡献。 但是这条链 阅读全文
posted @ 2026-05-20 20:49 WinterXorSnow 阅读(24) 评论(0) 推荐(0)
摘要: 题目链接 问题转化 考虑容斥,设 \(f_i\) 表示 \(i\) 个位置不合法的方案数。则答案为 \(n! - \sum\limits_{i=1}^n {(-1)}^i \cdot f_i \cdot (n-i)!\)。所以问题转化成如何快速求出 \(f_i\)。 不难发现对于每一个不合法的位置, 阅读全文
posted @ 2026-05-20 15:45 WinterXorSnow 阅读(20) 评论(0) 推荐(0)
摘要: 可恶的DP,竟然变成串串的模样来拷打我。(虽然好像是有用串串的写法的)。 如果只是从一边加,问题会非常坐牢,根本没法DP。因此我们考虑从两边加。 发现串长总和很小,也就是说,假设我们设置 \(f[i][j]\),其中 \(i,j\) 记录的都是当前在哪个串的哪个位置,那么复杂度我们是能够接受的。 因 阅读全文
posted @ 2026-05-20 12:48 WinterXorSnow 阅读(12) 评论(0) 推荐(0)
摘要: 题目链接 问题转化 问题不妨转化为 \(a \cdot f_{n-1} + b \cdot f_n \equiv 0 \pmod m\),要求找到最小的 \(n\) 满足这个条件。 不妨令 \(b = -b\),则有 \(a \cdot f_{n-1} \equiv b \cdot f_n \pmo 阅读全文
posted @ 2026-05-20 10:14 WinterXorSnow 阅读(19) 评论(0) 推荐(0)
摘要: 题目链接 我还是不太擅长这种节点可能记录无用信息的线段树。 DP 先想想 \(O(n^2)\) 单次的DP。定义 \(f_u\) 为处理完以 \(u\) 为根的子树所需要的答案。那么显然答案为 \(\max(\sum\limits_{v\in u} f_v,a_u)\)。 但是我们看着数据范围,肯定 阅读全文
posted @ 2026-05-20 07:47 WinterXorSnow 阅读(19) 评论(0) 推荐(0)
摘要: 题目链接 前置题目:CF1638E。 和 CF1638E 一样的套路。 不妨将所在的节点转变为颜色,同样的维护区间推平,颜色加,单点询问,唯一要变的就是还有树上距离的事情了。 如果不会,贴个我的题解。 Code #include<bits/stdc++.h> using namespace std; 阅读全文
posted @ 2026-05-19 20:24 WinterXorSnow 阅读(7) 评论(0) 推荐(0)
摘要: 题目链接 使用 BIT + ODT 维护的模版题。 套路 不妨将每一个点的答案拆成 \(a_x + val_{col}\),表示 \(x\) 之前累计起来的答案加上当前节点在当前颜色所产生的答案。 这个东西看似不好维护,实则可以通过一个巧妙的变化完成:记 \(tag_c\) 动态的维护当前颜色加上的 阅读全文
posted @ 2026-05-19 20:22 WinterXorSnow 阅读(17) 评论(0) 推荐(0)
摘要: 题目链接 疑似遇到天敌了。 注:以下下标均从 0 开始。 转化 这题一开始的转化是显然的,我们可以对于任意一个数字,转化成 \(a_j + w_i(j \equiv i \pmod m)\)。因此,我们可以记录 \(y_j = \max\limits_{i=l,j \equiv i \pmod m} 阅读全文
posted @ 2026-05-19 16:57 WinterXorSnow 阅读(16) 评论(0) 推荐(0)
摘要: 交互大人,拼尽全力无法战胜的。构造是构造不出来的,判定是不会判定的。 题目链接 思路 定义:与 1 直接有边相连的点为关键点。 那么我们不难证明的是,在删去与 1 有关的边后,所形成的联通块内如果有一个联通块满足关键点个数为奇数,则玛丽亚必胜。因为每一次选择 \(u,v\) 两个关键点删去,必然还会 阅读全文
posted @ 2026-05-18 16:23 WinterXorSnow 阅读(12) 评论(0) 推荐(0)